freemarker.template

## Class DefaultNonListCollectionAdapter

- java.lang.Object
- - freemarker.template.WrappingTemplateModel
  - - freemarker.template.DefaultNonListCollectionAdapter

All Implemented Interfaces:
  WrapperTemplateModel, AdapterTemplateModel, TemplateCollectionModel, TemplateCollectionModelEx, TemplateModel, TemplateModelWithAPISupport, Serializable

    public class DefaultNonListCollectionAdapter
    extends WrappingTemplateModel
    implements TemplateCollectionModelEx, AdapterTemplateModel, WrapperTemplateModel, TemplateModelWithAPISupport, Serializable

Experimental - subject to change: Adapts a non-`List` Java `Collection` to the corresponding `TemplateModel` interface(s), most importantly to `TemplateCollectionModelEx`. For `List`-s, use `DefaultListAdapter`, or else you lose indexed element access.

Thread safety: A `DefaultNonListCollectionAdapter` is as thread-safe as the `Collection` that it wraps is. Normally you only have to consider read-only access, as the FreeMarker template language doesn't allow writing these collections (though of course, Java methods called from the template can violate this rule).

This adapter is used by `DefaultObjectWrapper` if its `useAdaptersForCollections` property is `true`, which is the default when its `incompatibleImprovements` property is 2.3.22 or higher, and its `forceLegacyNonListCollections` property is `false`, which is still not the default as of 2.3.22 (so you have to set it explicitly).

Experimental status warning: This class is subject to change on non-backward compatible ways, hence, it shouldn't be used from outside FreeMarker yet.

Since:
  2.3.22
See Also:
  Serialized Form

### Field Summary

### Fields inherited from interface freemarker.template.TemplateModel

`NOTHING`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static DefaultNonListCollectionAdapter` `adapt(Collection collection, ObjectWrapperWithAPISupport wrapper)` Factory method for creating new adapter instances.
`boolean` `contains(TemplateModel item)` Tells if a given value occurs in the collection, accodring the rules of the wrapped collection.
`Object` `getAdaptedObject(Class hint)` Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
`TemplateModel` `getAPI()` Returns the model that exposes the (Java) API of the value.
`Object` `getWrappedObject()` Retrieves the original object wrapped by this model.
`boolean` `isEmpty()` Returns if the collection contains any elements.
`TemplateModelIterator` `iterator()` Retrieves a template model iterator that is used to iterate over the elements in this collection.
`int` `size()` Returns the number items in this collection, or `Integer.MAX_VALUE`, if there are more than `Integer.MAX_VALUE` items.

### Methods inherited from class freemarker.template.WrappingTemplateModel

`getDefaultObjectWrapper, getObjectWrapper, setDefaultObjectWrapper, setObjectWrapper, wrap`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### adapt

    public static DefaultNonListCollectionAdapter adapt(Collection collection,
                                                        ObjectWrapperWithAPISupport wrapper)

Factory method for creating new adapter instances.

Parameters:
  `collection` - The collection to adapt; can't be `null`.
  `wrapper` - The `ObjectWrapper` used to wrap the items in the array. Has to be `ObjectWrapperAndUnwrapper` because of planned future features.

#### iterator

    public TemplateModelIterator iterator()
                                   throws TemplateModelException

Description copied from interface: `TemplateCollectionModel`
Retrieves a template model iterator that is used to iterate over the elements in this collection.

Specified by:
  `iterator` in interface `TemplateCollectionModel`
Throws:
  `TemplateModelException`

#### size

    public int size()

Description copied from interface: `TemplateCollectionModelEx`
Returns the number items in this collection, or `Integer.MAX_VALUE`, if there are more than `Integer.MAX_VALUE` items.

Specified by:
  `size` in interface `TemplateCollectionModelEx`

#### isEmpty

    public boolean isEmpty()

Description copied from interface: `TemplateCollectionModelEx`
Returns if the collection contains any elements. This differs from `size() != 0` only in that the exact number of items need not be calculated.

Specified by:
  `isEmpty` in interface `TemplateCollectionModelEx`

#### getWrappedObject

    public Object getWrappedObject()

Description copied from interface: `WrapperTemplateModel`
Retrieves the original object wrapped by this model.

Specified by:
  `getWrappedObject` in interface `WrapperTemplateModel`

#### getAdaptedObject

    public Object getAdaptedObject(Class hint)

Description copied from interface: `AdapterTemplateModel`
Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.

Specified by:
  `getAdaptedObject` in interface `AdapterTemplateModel`
Parameters:
  `hint` - the desired class of the returned value. An implementation should make reasonable effort to retrieve an object of the requested class, but if that is impossible, it must at least return the underlying object as-is. As a minimal requirement, an implementation must always return the exact underlying object when `hint.isInstance(underlyingObject)` holds. When called with `java.lang.Object.class`, it should return a generic Java object (i.e. if the model is wrapping a scripting language object that is further wrapping a Java object, the deepest underlying Java object should be returned).
Returns:
  the underlying object, or its value accommodated for the hint class.

#### contains

    public boolean contains(TemplateModel item)
                     throws TemplateModelException

Description copied from interface: `TemplateCollectionModelEx`
Tells if a given value occurs in the collection, accodring the rules of the wrapped collection. As of 2.3.22, this interface is not yet utilized by FTL, and certainly it won't be earlier than 2.4.0. The usefulness of this method is questionable, as the equality rules of Java differs from that of FTL, hence, calling this won't be equivalent with `?seq_contains(e)`.

Specified by:
  `contains` in interface `TemplateCollectionModelEx`
Throws:
  `TemplateModelException`

#### getAPI

    public TemplateModel getAPI()
                         throws TemplateModelException

Description copied from interface: `TemplateModelWithAPISupport`
Returns the model that exposes the (Java) API of the value. This is usually implemented by delegating to `ObjectWrapperWithAPISupport.wrapAsAPI(Object)`.

Specified by:
  `getAPI` in interface `TemplateModelWithAPISupport`
Throws:
  `TemplateModelException`